SystemOrganization addCategory: #ObjectUsageTracer!

Object subclass: #ObjectUsageTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectUsageTracer'!

!ObjectUsageTracer methodsFor: 'enable - disable' stamp: 'MarianoMartinezPeck 12/22/2011 11:34'!
disableTracing
	self primitiveSetHasToTrace: true.
! !

!ObjectUsageTracer methodsFor: 'enable - disable' stamp: 'MarianoMartinezPeck 12/22/2011 11:34'!
enableTracing
	self primitiveSetHasToTrace: true.
! !

!ObjectUsageTracer methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/22/2011 11:39'!
getStadistics
	| anArray stadistics|
	anArray := self primitiveGetStadistics.
	stadistics := ObjectUsageTracerStatistics fromPrimitiveArray: anArray.
	^ stadistics ! !

!ObjectUsageTracer methodsFor: 'primitives' stamp: 'MarianoMartinezPeck 12/22/2011 11:32'!
primitiveGetStadistics 

	<primitive: 154>	"successful completion returns an Array with the stadistics numbers"
	^  self primitiveFailed 
! !

!ObjectUsageTracer methodsFor: 'primitives' stamp: 'MarianoMartinezPeck 12/22/2011 11:33'!
primitiveSetHasToTrace: aBoolean

	<primitive: 153>	"successful completion returns self"
	^  self primitiveFailed 
! !

!ObjectUsageTracer methodsFor: 'start - stop' stamp: 'MarianoMartinezPeck 12/22/2011 11:36'!
startTracing
	self unmarkAllObjects.
	self enableTracing.
	! !

!ObjectUsageTracer methodsFor: 'start - stop' stamp: 'MarianoMartinezPeck 12/22/2011 11:36'!
stopTracing
	self disableTracing.
	! !

!ObjectUsageTracer methodsFor: 'start - stop' stamp: 'MarianoMartinezPeck 12/22/2011 11:37'!
stopTracingAndGetStadistics
	self disableTracing.
	^ self getStadistics.
! !

!ObjectUsageTracer methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/22/2011 11:35'!
unmarkAllObjects
	ExperimentalBitHandler turnOffExperimentalBitOfAllObjects! !

Object subclass: #ObjectUsageTracerStatistics
	instanceVariableNames: 'unusedCount usedCount objectCount unusedPercentage usedPercentage usedMemory unusedMemory totalMemory percentageUsedMemory percentageUnusedMemory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectUsageTracer'!

!ObjectUsageTracerStatistics class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
fromPrimitiveArray: anArray
	| usedCount unusedCount usedMemory unusedMemory objectsCount totalMemory |
	usedCount := (anArray at: 1).
	unusedCount := (anArray at: 2).
	usedMemory  := (anArray at: 3).
	unusedMemory  := (anArray at: 4).
	
	objectsCount := usedCount + unusedCount.
	totalMemory := unusedMemory + usedMemory.
	^ self new
		usedCount: usedCount;
		unusedCount: unusedCount;
		objectCount: objectsCount;
		unusedPercentage: ((unusedCount * 100) / objectsCount) asFloat;
		usedPercentage: ((usedCount * 100) / objectsCount) asFloat;
		usedMemory: usedMemory;
		unusedMemory: unusedMemory;
		totalMemory: totalMemory;
		percentageUnusedMemory: ((unusedMemory * 100) / totalMemory) asFloat;
		percentageUsedMemory: ((usedMemory * 100) / totalMemory) asFloat
		 ! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
objectCount
	^ objectCount! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
objectCount: anObject
	objectCount := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
percentageUnusedMemory
	^ percentageUnusedMemory! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
percentageUnusedMemory: anObject
	percentageUnusedMemory := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
percentageUsedMemory
	^ percentageUsedMemory! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
percentageUsedMemory: anObject
	percentageUsedMemory := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
printOn: aStream
	aStream 
		nextPutAll: 'Total amount of objects: ', self objectCount asString, String cr;
		nextPutAll: 'Amount of used objects: ', self usedCount asString, String cr;
		nextPutAll: 'Percentage of used objects: ', self usedPercentage asString, String cr;
		nextPutAll: 'Amount of unused objects: ', self unusedCount asString, String cr;
		nextPutAll: 'Percentage of unused objects: ', self unusedPercentage asString, String cr;
		nextPutAll: String cr;
		nextPutAll: 'Total bytes of memory used: ', self totalMemory  asString, String cr;
		nextPutAll: 'Bytes of memory for the used objects: ', self usedMemory asString, String cr;
		nextPutAll: 'Percentage of memory for the used objects: ', self percentageUsedMemory asString, String cr;
		nextPutAll: 'Bytes of memory for the unused objects: ', self unusedMemory asString, String cr;
		nextPutAll: 'Percentage of memory for the unused objects: ', self percentageUnusedMemory asString, String cr.
	! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
totalMemory
	^ totalMemory! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
totalMemory: anObject
	totalMemory := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedCount
	^ unusedCount! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedCount: anObject
	unusedCount := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedMemory
	^ unusedMemory! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedMemory: anObject
	unusedMemory := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedPercentage
	^ unusedPercentage! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
unusedPercentage: anObject
	unusedPercentage := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedCount
	^ usedCount! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedCount: anObject
	usedCount := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedMemory
	^ usedMemory ! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedMemory: anObject
	usedMemory := anObject! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedPercentage
	^ usedPercentage! !

!ObjectUsageTracerStatistics methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/22/2011 11:38'!
usedPercentage: anObject
	usedPercentage := anObject! !
